unit sms_;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WinINET, HttpAPP;




type
  Tsms = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Memo1: TMemo;
    Label3: TLabel;
    Memo2: TMemo;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    procedure Memo2Change(Sender: TObject);
    function Sendsms(const Username, Password, commandtype,xml:string):string;
    procedure Button1Click(Sender: TObject);
    function get_send_xml:string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  sms: Tsms;

implementation

uses resultxml_;

{$R *.dfm}

function Tsms.Sendsms(const Username, Password, commandtype,xml:string):string;
{
This function will connect to the internet, send the url and return the XML object returned by the API (string)
}
    const
      URL = 'http://www.mymobileapi.com/api5/http5.aspx?type=%s&username=%s&password=%s&XMLData=%s';
      ResponseSize = 1024;
    var
      hSession, hURL: HInternet;
      Request: String;
      ResponseLength: Cardinal;
    begin
      hSession := InternetOpen('sendsms', INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);
      try
        Request := Format(URL,[commandtype,username,password,xml]);
        hURL := InternetOpenURL(hSession, PChar(Request), nil, 0,0,0);
        try
          SetLength(Result, ResponseSize);
          InternetReadFile(hURL, PChar(Result), ResponseSize,
            ResponseLength);
          SetLength(Result, ResponseLength)
        finally
          InternetCloseHandle(hURL)
        end
      finally
        InternetCloseHandle(hSession)
      end
    end;

function Tsms.get_send_xml:string;
{this function will create the xml part of the command}
var
send_xml:tstrings;
x:integer;
begin
      send_xml:= tstringlist.create;
      send_xml.add('<senddata>');
      send_xml.add('<settings>');
      send_xml.add('<live>True</live>');
      send_xml.add('<return_entries_success_status>True</return_entries_success_status>');
      send_xml.add('<default_date>20/Aug/2009</default_date>');
      send_xml.add('<default_time>11:15</default_time>');
      send_xml.add('<default_data1>' + memo2.text + '</default_data1>');
      send_xml.add('<default_flash>False</default_flash>');
      send_xml.add('<default_type>SMS</default_type>');
      send_xml.add('</settings>');

      for x := 0 to memo1.lines.count - 1 do
        begin
          if length(trim(memo1.Lines[x])) = 10 then //is length of entered cellno = 10 ?
            begin
              send_xml.add('<entries>');
              send_xml.add('<numto>' + memo1.lines[x] + '</numto>');
              //customer id must be supplied by program - like accnumber etc.
              send_xml.add('<customerid>' + 'Customer_id' + '</customerid>');
              send_xml.add('</entries>');
            end;
        end;

      send_xml.add('</senddata>');
      result := send_xml.text;
      send_xml.destroy;
end;

procedure Tsms.Button1Click(Sender: TObject);
begin
  resultxml.memo1.text := sendsms(edit1.Text,edit2.text,'send',get_send_xml);
  resultxml.showmodal;
end;

procedure Tsms.Memo2Change(Sender: TObject);
begin
  label5.caption := inttostr(160 - length(memo2.text));
end;

end.
